Sign in Start for free

Progression

Return a list of runbook dashboard items, filtered by various criteria including projectIds, environmentIds, tenantIds, tenantTags, runbookIds, runbookTags, taskIds

GET /api/{spaceId}/progression/runbooks/taskRuns

Also reachable at /api/progression/runbooks/taskRuns, /api/spaces/{spaceIdentifier}/progression/runbooks/taskRuns.

Path Parameters

  • spaceId string (required)
    ID of the space.

Query Parameters

  • environmentIds array of string
  • projectIds array of string
  • runbookIds array of string
  • runbookTags array of string
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.
  • taskIds array of string
  • tenantIds array of string
  • tenantTags array of string

Response

200 — The list of runbook dashboard items

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • CompletedTime string
      Format date-time.
    • Created string
      Format date-time.
    • Duration string
    • EnvironmentId string
    • ErrorMessage string
    • GitReference object
    • HasPendingInterruptions boolean
    • HasPendingPreconditions boolean
    • HasWarningsOrErrors boolean
    • Id string
      Gets or sets a unique identifier for this resource.
    • IsCompleted boolean
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • PendingInterruptionTypes array of enum
      Allowed values: ManualIntervention, GuidedFailure, PullRequestCompletion, ArgoCDApplicationSync, KubernetesResourceVerification.
    • PendingPreconditionTypes array of string
    • ProjectId string
    • QueueTime string
      Format date-time.
    • RunBy string
    • RunName string
    • RunbookId string
    • RunbookSnapshotId string
    • RunbookSnapshotName string
    • RunbookSnapshotNotes string
    • StartTime string
      Format date-time.
    • State enum
      Allowed values: Queued, Executing, Failed, Canceled, TimedOut, Success, Cancelling.
    • TaskId string
    • TenantId string
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "CompletedTime": "2020-01-01T00:00:00.000Z",
      "Created": "2020-01-01T00:00:00.000Z",
      "Duration": "string",
      "EnvironmentId": "Environments-1",
      "ErrorMessage": "string",
      "GitReference": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "HasPendingInterruptions": true,
      "HasPendingPreconditions": true,
      "HasWarningsOrErrors": true,
      "Id": "string",
      "IsCompleted": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "PendingInterruptionTypes": [
        "ManualIntervention"
      ],
      "PendingPreconditionTypes": [
        "string"
      ],
      "ProjectId": "Projects-1",
      "QueueTime": "2020-01-01T00:00:00.000Z",
      "RunBy": "string",
      "RunName": "string",
      "RunbookId": "string",
      "RunbookSnapshotId": "string",
      "RunbookSnapshotName": "string",
      "RunbookSnapshotNotes": "string",
      "StartTime": "2020-01-01T00:00:00.000Z",
      "State": "Queued",
      "TaskId": "string",
      "TenantId": "Tenants-1"
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Get the progress of a runbook in the environment lifecycle

GET /api/{spaceId}/progression/runbooks/{runbookId}

Also reachable at /api/progression/runbooks/{runbookId}, /api/spaces/{spaceIdentifier}/progression/runbooks/{runbookId}.

Path Parameters

  • runbookId string (required)
    ID of the Runbook.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — The requested Runbook Progression information

  • Environments array of object
    • Id string
    • Name string
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • RunbookRuns object

Example Response

JSON
{
  "Environments": [
    {
      "Id": "string",
      "Name": "string"
    }
  ],
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "RunbookRuns": {
    "additionalProp1": [
      {
        "CompletedTime": "2020-01-01T00:00:00.000Z",
        "Created": "2020-01-01T00:00:00.000Z",
        "Duration": "string",
        "EnvironmentId": "Environments-1",
        "ErrorMessage": "string",
        "GitReference": {},
        "HasPendingInterruptions": true,
        "HasPendingPreconditions": true,
        "HasWarningsOrErrors": true,
        "Id": "string",
        "IsCompleted": true,
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "Links": {},
        "PendingInterruptionTypes": [
          "ManualIntervention"
        ],
        "PendingPreconditionTypes": [
          "string"
        ],
        "ProjectId": "Projects-1",
        "QueueTime": "2020-01-01T00:00:00.000Z",
        "RunBy": "string",
        "RunName": "string",
        "RunbookId": "string",
        "RunbookSnapshotId": "string",
        "RunbookSnapshotName": "string",
        "RunbookSnapshotNotes": "string",
        "StartTime": "2020-01-01T00:00:00.000Z",
        "State": "Queued",
        "TaskId": "string",
        "TenantId": "Tenants-1"
      }
    ],
    "additionalProp2": [
      {
        "CompletedTime": "2020-01-01T00:00:00.000Z",
        "Created": "2020-01-01T00:00:00.000Z",
        "Duration": "string",
        "EnvironmentId": "Environments-1",
        "ErrorMessage": "string",
        "GitReference": {},
        "HasPendingInterruptions": true,
        "HasPendingPreconditions": true,
        "HasWarningsOrErrors": true,
        "Id": "string",
        "IsCompleted": true,
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "Links": {},
        "PendingInterruptionTypes": [
          "ManualIntervention"
        ],
        "PendingPreconditionTypes": [
          "string"
        ],
        "ProjectId": "Projects-1",
        "QueueTime": "2020-01-01T00:00:00.000Z",
        "RunBy": "string",
        "RunName": "string",
        "RunbookId": "string",
        "RunbookSnapshotId": "string",
        "RunbookSnapshotName": "string",
        "RunbookSnapshotNotes": "string",
        "StartTime": "2020-01-01T00:00:00.000Z",
        "State": "Queued",
        "TaskId": "string",
        "TenantId": "Tenants-1"
      }
    ],
    "additionalProp3": [
      {
        "CompletedTime": "2020-01-01T00:00:00.000Z",
        "Created": "2020-01-01T00:00:00.000Z",
        "Duration": "string",
        "EnvironmentId": "Environments-1",
        "ErrorMessage": "string",
        "GitReference": {},
        "HasPendingInterruptions": true,
        "HasPendingPreconditions": true,
        "HasWarningsOrErrors": true,
        "Id": "string",
        "IsCompleted": true,
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "Links": {},
        "PendingInterruptionTypes": [
          "ManualIntervention"
        ],
        "PendingPreconditionTypes": [
          "string"
        ],
        "ProjectId": "Projects-1",
        "QueueTime": "2020-01-01T00:00:00.000Z",
        "RunBy": "string",
        "RunName": "string",
        "RunbookId": "string",
        "RunbookSnapshotId": "string",
        "RunbookSnapshotName": "string",
        "RunbookSnapshotNotes": "string",
        "StartTime": "2020-01-01T00:00:00.000Z",
        "State": "Queued",
        "TaskId": "string",
        "TenantId": "Tenants-1"
      }
    ]
  }
}

Get the progress of a runbook in the environment lifecycle

GET /api/{spaceId}/progression/runbooks/{runbookId}/v1

Also reachable at /api/progression/runbooks/{runbookId}/v1, /api/spaces/{spaceIdentifier}/progression/runbooks/{runbookId}/v1.

Path Parameters

  • runbookId string (required)
    ID of the Runbook.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — The requested Runbook Progression information

  • Progression object
    • Environments array of object
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • RunbookRuns object

Example Response

JSON
{
  "Progression": {
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "RunbookRuns": {
      "additionalProp1": [
        {}
      ],
      "additionalProp2": [
        {}
      ],
      "additionalProp3": [
        {}
      ]
    }
  }
}

Get the progress of a release in the environment lifecycle

GET /api/{spaceId}/progression/{projectId}

Also reachable at /api/progression/{projectId}, /api/projects/{projectId}/progression, /api/spaces/{spaceIdentifier}/progression/{projectId}, /api/spaces/{spaceIdentifier}/projects/{projectId}/progression, /api/{spaceId}/projects/{projectId}/progression.

Path Parameters

  • projectId string (required)
    ID of the Project.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • releaseHistoryCount integer
    Number of releases to include per environment/channel/tenant combination. Defaults to 3. Maximum allowed is 100. Minimum 1. Maximum 100.

Response

200 — The requested Project Progression information

  • ChannelEnvironments object
  • Environments array of object
    • Id string
    • Name string
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LifecycleEnvironments object
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Releases array of object
    • Channel object
    • Deployments object
    • HasUnresolvedDefect boolean
    • NextDeployments array of string
    • Release object
    • ReleaseRetentionPeriod object
    • TentacleRetentionPeriod object

Example Response

JSON
{
  "ChannelEnvironments": {
    "additionalProp1": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "additionalProp2": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "additionalProp3": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "Environments": [
    {
      "Id": "string",
      "Name": "string"
    }
  ],
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LifecycleEnvironments": {
    "additionalProp1": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "additionalProp2": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "additionalProp3": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Releases": [
    {
      "Channel": {
        "AutomaticEphemeralEnvironmentDeployments": true,
        "CustomFieldDefinitions": [
          {}
        ],
        "Description": "string",
        "EphemeralEnvironmentNameTemplate": "string",
        "GitReferenceRules": [
          "string"
        ],
        "GitResourceRules": [
          {}
        ],
        "Id": "string",
        "IsDefault": true,
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "LifecycleId": "string",
        "Links": {},
        "Name": "string",
        "ParentEnvironmentId": "Environments-1",
        "ProjectId": "Projects-1",
        "Rules": [
          {}
        ],
        "Slug": "string",
        "SpaceId": "Spaces-1",
        "TenantTags": [
          "string"
        ],
        "Type": "string"
      },
      "Deployments": {
        "additionalProp1": [
          {}
        ],
        "additionalProp2": [
          {}
        ],
        "additionalProp3": [
          {}
        ]
      },
      "HasUnresolvedDefect": true,
      "NextDeployments": [
        "Environments-1",
        "..."
      ],
      "Release": {
        "Assembled": "2020-01-01T00:00:00.000Z",
        "BuildInformation": [
          {}
        ],
        "ChannelId": "Channels-1",
        "CustomFields": {},
        "Id": "Releases-1",
        "IgnoreChannelRules": true,
        "LastModifiedBy": "string",
        "LastModifiedOn": "2020-01-01T00:00:00.000Z",
        "LibraryVariableSetSnapshotIds": [
          "string"
        ],
        "Links": {},
        "ProjectDeploymentProcessSnapshotId": "string",
        "ProjectId": "Projects-1",
        "ProjectVariableSetSnapshotId": "string",
        "ReleaseNotes": "string",
        "SelectedGitResources": [
          {}
        ],
        "SelectedPackages": [
          {}
        ],
        "SpaceId": "Spaces-1",
        "VariableSnapshotConcurrencyToken": "string",
        "Version": "string",
        "VersionControlReference": {}
      },
      "ReleaseRetentionPeriod": {
        "QuantityToKeep": 0,
        "ShouldKeepForever": true,
        "Strategy": "string",
        "Unit": "Days"
      },
      "TentacleRetentionPeriod": {
        "QuantityToKeep": 0,
        "ShouldKeepForever": true,
        "Strategy": "string",
        "Unit": "Days"
      }
    }
  ]
}

Get the progress of a release in the environment lifecycle

GET /api/{spaceId}/projects/{projectId}/progression/v1

Also reachable at /api/projects/{projectId}/progression/v1, /api/spaces/{spaceIdentifier}/projects/{projectId}/progression/v1.

Path Parameters

  • projectId string (required)
    ID of the Project.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • releaseHistoryCount integer
    Number of releases to include per environment/channel/tenant combination. Defaults to 3. Maximum allowed is 100. Minimum 1. Maximum 100.

Response

200 — The requested Project Progression information

  • Progression object
    • ChannelEnvironments object
    • Environments array of object
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • LifecycleEnvironments object
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • Releases array of object

Example Response

JSON
{
  "Progression": {
    "ChannelEnvironments": {
      "additionalProp1": [
        {}
      ],
      "additionalProp2": [
        {}
      ],
      "additionalProp3": [
        {}
      ]
    },
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "LifecycleEnvironments": {
      "additionalProp1": [
        {}
      ],
      "additionalProp2": [
        {}
      ],
      "additionalProp3": [
        {}
      ]
    },
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "Releases": [
      {
        "Channel": {},
        "Deployments": {},
        "HasUnresolvedDefect": true,
        "NextDeployments": [
          "Environments-1",
          "..."
        ],
        "Release": {},
        "ReleaseRetentionPeriod": {},
        "TentacleRetentionPeriod": {}
      }
    ]
  }
}